
var DragInfoGraphicPoints = null;

(function($){
  
  DragInfoGraphicPoints = DragInfoGraphic.extend({
      
     init: function(options) {
		 this.defaults = {
		     canvas: '#dragGraphicCanvas',
		     button: '#next',
		     space: 10,
			 zones: [
				 {node:"#zone1", className:"leftTop", label: 'lernen & spielen', color: '##12C0E7', width:"calc(50% - 7px)", height:"calc(50% - 3px)", top:0, left:0, padding:'37px 10px 10px 10px'},
				 {node:"#zone2", className:"rightTop", label: 'suchen & informieren', color: '#ff8100', width:"49.5%", height:"calc(50% - 3px)", top:0, left:"50.5%", padding:'37px 10px 10px 10px'},
				 {node:"#zone3", className:"leftBottom", label: 'sehen & hören', color: '#95C11E', width:"49.5%", height:"calc(50% - 12px)", top:"calc(50% + 12px)", left:0, padding:'37px 10px 10px 10px'},
				 {node:"#zone4", className:"rightBottom", label: 'kommunizieren & teilen', color: '#bd48cb', width:"49.5%", height:"calc(50% - 12px)", top:"calc(50% + 12px)", left:"50.5%", padding:'37px 10px 10px 10px'}
			 ],
		     statusNode: '#zonebudget',
		     iconBar: '#bar',
			 icons: [
				 {glyph: 'Angry-Birds.png', info: 'Angry-Birds'}, //1
				 {glyph: 'neu2020/Minecraft.png', info: 'Minecraft'}, //2
				 {glyph: 'neu2020/Candy_Crush.png', info: 'Candy-Crush'}, //3
				 {glyph: 'Kamera.png', info: 'Kamera'}, //4
				 {glyph: 'YouTube.png', info: 'YouTube'}, //5
				 {glyph: 'Spotify.png', info: 'Spotify'}, //6
				 {glyph: 'neu2020/TikTok.png', info: 'TikTok'}, //7
				 {glyph: 'Instagram.png', info: 'Instagram'}, //8
				 {glyph: 'Mail-Apple.png', info: 'Mail Apple'}, //9
				 {glyph: 'facebook.png', info: 'Facebook'}, //10
				 {glyph: 'Skype.png', info: 'Skype'}, //11
				 {glyph: 'SMS-Android.png', info: 'SMS-Android'}, //12
				 {glyph: 'SnapChat.png', info: 'SnapChat'}, //13
				 {glyph: 'neu2020/Twitter.png', info: 'Twitter'}, //14
				 {glyph: 'Wahtsapp.png', info: 'WhatsApp'}, //15
				 {glyph: 'neu2020/Google_Maps.png', info: 'Google-Maps'}, //16
				 {glyph: 'Safari.png', info: 'Safari'}, //17
				 {glyph: 'neu2020/bing.png', info: 'Bing'}, //18
				 {glyph: 'neu2020/Google.png', info: 'Google'}, //19
				 {glyph: 'neu2020/Google_Play.png', info: 'Google-Play'}, //20
				 {glyph: 'neu2020/Netflix.png', info: 'Netflix'}, //21
				 {glyph: 'Wikipedia.png', info: 'Wikipedia'}, //22
				 {glyph: 'Viber.png', info: 'Viber'}, //23
				 {glyph: 'neu2020/Shazam.png', info: 'Shazam'}, //24
				 {glyph: 'neu2020/twitch.png', info: 'Twitch'}, //25
				 {glyph: 'neu2020/Vimeo.png', info: 'Vimeo'} //26

				 /*
					{glyph: 'Bing-Maps.png', info: 'Bing Maps'},
					{glyph: 'Apple-sms.png', info: 'Apple-SMS'},
					{glyph: 'Gmail.png', info: 'Gmail'},
					{glyph: 'Jappy.png', info: 'Jappy'},
					{glyph: 'neu2020/bing.png', info: 'Bing'},
					{glyph: 'last-fm.png', info: 'Last-Fm'},
					{glyph: 'myVideo.png', info: 'myVideo'},
					{glyph: 'Apple-Karten.png', info: 'Appel Maps'},
					{glyph: 'Game-Center-Apple.png', info: 'Gamecenter Appel'},
					{glyph: 'FB-Messenger.png', info: 'Facebook Messenger'},
				 	{glyph: 'Flickr.png', info: 'Flickr'},
				  */

			 ],
			 matrix: [
				 { zone1: 'green', zone2: 'red', zone3: 'red', zone4: 'yellow'}, //Angry-Birds 1
				 { zone1: 'green', zone2: 'red', zone3: 'red', zone4: 'yellow'},  //Minecraft 2
				 { zone1: 'green', zone2: 'red', zone3: 'red', zone4: 'red'}, //Candy-Crush 3
				 { zone1: 'green', zone2: 'red', zone3: 'yellow', zone4: 'red'}, //Kamera 4
				 { zone1: 'yellow', zone2: 'green', zone3: 'green', zone4: 'yellow'}, //YouTube 5
				 { zone1: 'red', zone2: 'yellow', zone3: 'green', zone4: 'yellow'}, //Spotify 6
				 { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'yellow'}, //TikTok 7
				 { zone1: 'red', zone2: 'yellow', zone3: 'green', zone4: 'green'}, //Instagram 8
				 { zone1: 'red', zone2: 'yellow', zone3: 'red', zone4: 'green'}, //Mail-Apple 9
				 { zone1: 'red', zone2: 'yellow', zone3: 'yellow', zone4: 'green'}, //Facebook 10
				 { zone1: 'red', zone2: 'red', zone3: 'yellow', zone4: 'green'}, //Skype 11
				 { zone1: 'red', zone2: 'red', zone3: 'red', zone4: 'green'}, //SMS Android 12
				 { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'green'}, //SnapChat 13
				 { zone1: 'red', zone2: 'green', zone3: 'yellow', zone4: 'green'}, //Twitter 13
				 { zone1: 'red', zone2: 'red', zone3: 'red', zone4: 'green'}, //Wahtsapp 14
				 { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Google-Maps 15
				 { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Safari 16
				 { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Bing 17
				 { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Google 18
				 { zone1: 'yellow', zone2: 'green', zone3: 'red', zone4: 'red'},  //Google-Play 19
				 { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'red'},  //Netflix 20
				 { zone1: 'red', zone2: 'green', zone3: 'red', zone4: 'red'}, //Wikipedia 21
				 { zone1: 'red', zone2: 'red', zone3: 'yellow', zone4: 'green'}, //Viber 22
				 { zone1: 'red', zone2: 'yellow', zone3: 'yellow', zone4: 'yellow'}, //Shazam 23
				 { zone1: 'yellow', zone2: 'yellow', zone3: 'green', zone4: 'yellow'}, //Twitch 24
				 { zone1: 'yellow', zone2: 'green', zone3: 'green', zone4: 'yellow'} //Vimeo 25


				 /*
                 { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'red'}, //Bing-Maps
                 { zone1: 'green', zone2: 'yellow', zone3: 'yellow', zone4: 'yellow'}, //Gmail
                 { zone1: 'green', zone2: 'green', zone3: 'yellow', zone4: 'yellow'}, //Jappy
                 { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'yellow'}, //SMS-Android
                 { zone1: 'green', zone2: 'yellow', zone3: 'yellow', zone4: 'yellow'}, //Twitter
                 { zone1: 'red', zone2: 'yellow', zone3: 'green', zone4: 'red'}, //Bing
                 { zone1: 'yellow', zone2: 'green', zone3: 'yellow', zone4: 'yellow'}, //Last-Fm
                 { zone1: 'yellow', zone2: 'yellow', zone3: 'green', zone4: 'green'},  //myVideo
                 { zone1: 'red', zone2: 'red', zone3: 'green', zone4: 'red'},  //Appel-Maps
                 { zone1: 'yellow', zone2: 'green', zone3: 'red', zone4: 'red'},  //Gamecenter-Appel
                 { zone1: 'green', zone2: 'yellow', zone3: 'red', zone4: 'red'},  //FB-Messenger
                 { zone1: 'green', zone2: 'green', zone3: 'yellow', zone4: 'green'},  //Flickr
                  */

			 ],
		     resultTexte: {
				 red: { img:'/img/igraph/k_red.jpg', text: 'Ups!', text2: 'Vielleicht schaust du dir die Apps noch einmal genauer an?'},
				 yellow: { img:'/img/igraph/k_yellow.jpg', text: 'Ok!', text2: 'Du kennst dich aus und bist auf dem richtigen Weg!'},
				 green: { img:'/img/igraph/k_green.jpg', text: 'Super!', text2: 'Du weißt ja richtig gut Bescheid, weiter so!'}
		     },
		     iconViewLength: 6
		 }
		 
		 this.opt = $.extend(this.defaults, options);	 
		 this._super(this.opt);	 
     },
     
     createViews: function() {
		 var self = this;
		 this._super();
		 this.opt.iconBar.find('.icon').each(function(i, elem) {
		     $(elem).attr('matrix_index', i);
		 });
     },
     
     initZoneDrags: function() {
		 var self = this;
		 this._super();		
		 $('.icon').tooltip({title: 'title'});
		 this.opt.canvas.find('.zone .icon').each(function(i, elem) {
		     var item = self.getItem ( $(elem).attr('item_id') );
		     item.hideSmallView();
		 });
     },
     
     openDialog: function() {
    	 var self = this;
    	 var status = this.updateStatus();
    	 this.status = status;
    	 
		 $( "#g_header" ).html(this.opt.resultTexte[status].text);
		 $( "#g_cont" ).html(
				 //'<h2>'+this.opt.resultTexte[status].text+"</h2>"
				 //+'<img src="'+this.opt.resultTexte[status].img+'" style="padding:10px 0px;"/>'
				 this.opt.resultTexte[status].text2
		 );
		 $('#g_dialog').on('hidden', function () {
			//window.location.href = self.opt.gotoUrl;
		 });
		 $( "#g_dialog" ).modal('show');
     },
     
     createItem: function(node) {
		 this.itemStackIndex++;
		 
		 var item = new DragPointItem({
		     canvas: node,
		     id: this.itemStackIndex,
		     control: this
		 });
		 this.itemStack.push(item);
		 return item;
     },
     
     
     updateStatus: function() {
		var self = this;
		 
		 var redExists = false;
		 var points = 0;
		 for(var i=0; i < this.opt.zones.length; i++) {
		     this.opt.zones[i].node.find('.icon').each(function(y, elem) {
			 var item = self.getItem( $(elem).attr('item_id') );
			 item.setSmallView();
			 var status = item.getStatus();
			 switch(status) {
			    case 'green':
				 points++;
				 break;
			    case 'red':
				 points--;
				 redExists=true;
				 break;
			    case 'yellow':
				 points += 0.5;
				 break; 
			 }
		     }); 
		 }
		 
		 this.opt.statusNode.removeClass('red');
		 this.opt.statusNode.removeClass('yellow');
		 this.opt.statusNode.removeClass('green');
		 
		 if(redExists) {
		     if(points >= 0) {
			 this.opt.statusNode.addClass('yellow');
			return 'yellow';
		     }else {
			this.opt.statusNode.addClass('red');
			return 'red';
		     }
		 }else {	     
		     if(points == 0){
			 this.opt.statusNode.addClass('yellow');
			 return 'yellow';
		     }else {
			 this.opt.statusNode.addClass('green');
			 return 'green';
		     }
		 }
	 
     },
     
     getJson: function() {
		 var value = Array();	 
		 for(var i=0; i < this.itemStack.length; i++) {
		     var obj = {
			zone: '',
			matrix_index: '',
			classNames: '',
			iconHtml: '',
			opt: null
		     };
		     
		     obj.zone = '#'+this.itemStack[i].opt.canvas.parent().attr("id");
		     obj.matrix_index = this.itemStack[i].opt.canvas.attr('matrix_index');
		     obj.classNames = this.itemStack[i].opt.canvas.attr('class');
		     obj.iconHtml = '<span class="'+this.itemStack[i].opt.canvas.find('span:first').attr('class')+'"><i></i></span>';
		     obj.opt = jQuery.extend({}, this.itemStack[i].opt);
		     obj.opt.canvas = null;
		     obj.opt.control = null;
		     value.push(obj);
		 }	 
		 
		 console.log( JSON.stringify(value) );
		 return JSON.stringify(value);
     },
     
     loadJson: function(str) {
    	 var self = this;
		 //var str = [{"zone":"#zone4","matrix_index":"4","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons binoculars\"><i></i></span>","opt":{"canvas":null,"id":1,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone2","matrix_index":"5","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons road\"><i></i></span>","opt":{"canvas":null,"id":2,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone3","matrix_index":"1","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons fire\"><i></i></span>","opt":{"canvas":null,"id":3,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone3","matrix_index":"2","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons magnet\"><i></i></span>","opt":{"canvas":null,"id":4,"type":null,"data":{"desc":"","price":0},"control":null}},{"zone":"#zone1","matrix_index":"3","classNames":"icon ui-draggable inzone","iconHtml":"<span class=\"glyphicons parents\"><i></i></span>","opt":{"canvas":null,"id":5,"type":null,"data":{"desc":"","price":0},"control":null}}];
		 var value = str;
		 
		 for(var i=0; i < value.length; i++) {
		     try { 
                        var node = $('<div title="'+self.opt.icons[value[i].matrix_index].info+'" class="'+value[i].classNames+'" matrix_index="'+value[i].matrix_index+'">'+value[i].iconHtml+'</div>');
                        value[i].opt.canvas = node;
                        value[i].opt.control = this;
                        $(value[i].zone).append(node);
                        var item = this.createItem(node, value[i].opt);
                    }catch(e){
                        return;
                    }
		 }
		 
		 this.initZoneDrags();
		 this.updateStatus();
     }      
     
  });

})(jQuery);
