

var DragPointItem = null;

(function($){
  
  DragPointItem = Class.extend({
      
     init: function(options) {
	 var self = this;	    
	 this.defaults = {
	     canvas: null,
	     id: null,
	     type: null,
	     data: { desc:'', price: 0},
	     control: null
	 }
	 this.opt = $.extend(this.defaults, options);
	 
	 this.opt.canvas = $(this.opt.canvas);
	 this.opt.canvas.attr('item_id', this.opt.id);	

	 this.inDrag = false; 
	 this.matrixIndex = parseInt( this.opt.canvas.attr('matrix_index') );
	 
	 this.from = $(	'<div class="small"></div>');	
	 this.opt.canvas.append(this.from); 	 
     },
      
     getStatus: function() {
	 var zoneId = this.opt.canvas.parent().attr('id');
	 return this.opt.control.opt.matrix[this.matrixIndex][zoneId];
     },
      
     setSmallView: function() {
	 var n = this.opt.canvas.find('.small').first();
	 n.attr('class', '')
	    .addClass( 'small' )
	    .addClass( this.getStatus() );
     },
     
     hideSmallView: function() {
	 var n = this.opt.canvas.find('.small').first();
	 n.attr('class', '').addClass( 'small' );
     },
     
     showForm: function() {
     },
     
     hideForm: function() {
     },
     
     destroy: function() {
	 var self = this;
	 self.opt.canvas.remove();
     }
 
  })
  
})(jQuery)